/* ====================================================================
 * ===  Copyright (C) 1998-2003 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 * 
 *    Project              : SagCAD
 *    Description          : CAD/CAM
 *    Source               : PostScript.c
 * 
 *    ----------------------------------
 * 
 *    Copyright            : (C) 1998-2003 by Yutaka Sagiya
 *    email                : kappa@a6s.highway.ne.jp
 *                         : yutaka@sagiya.com
 *    Begin                : 2003/04/01
 *    Last                 : 2003/04/01
 * ====================================================================
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "etc.h"
#include "Trace.h"

#define _POSTSCRIPT_
#include "PostScript.h"





/* -------------------------------------------------------------------
 * PostScript ¸
 * 

         cm          points
a3  29.7 x 42.0    842 x 1190
a4  21.0 x 29.7    595 x  842
a5  14.9 x 21.0    421 x  595
b5  17.7 x 25.0    501 x  709
1 dict dup /PageSize [842 595] put setpagedevice /ImagingBBox [20 20 802 555] put setpagedevice

 */
int PostScript(char *SaveFileName)
{
	char FileName[256];
	FILE *stream;


	/* Open */
	sprintf(FileName, "%s", SaveFileName);
	cutExtName(FileName);
	strcat(FileName, ".ps");
	if ((stream = fopen( FileName, "w")) == NULL) {
		printf("ե %s ϳޤǤ\n", FileName);
	}


	/* PostScript ε */
	set_start_up(stream);


	/* Close */
	fclose(stream);
	printf("ե %s ¸ޤ\n", FileName);
	return 1;
}





/* -------------------------------------------------------------------
 * Ͻ
 * 
 */
int set_start_up(FILE *stream)
{
	char str[256];

	/* PostScript ε */
	sprintf(str, "%!PS-Adobe-3.0\n");
	fputs(str, stream );
	return 1;
}





/* -------------------------------------------------------------------
 * 
 * 
 */
int set_line_width(FILE *stream, int width)
{
	char str[256];

	sprintf(str, "%d setlinewidth\n", width);
	fputs(str, stream );
	return 1;
}





/* -------------------------------------------------------------------
 * 
 * 
 */
int set_line_color(FILE *stream, long color)
{
	char str[256];
	struct ColorDat coldat;

	coldat.rgb = color;
	color_split(&coldat);

	sprintf(str, "%f %f %f setrgbcolor\n", 
				 ((double)coldat.red)/256, 
				 ((double)coldat.green)/256, 
				 ((double)coldat.blue)/256);
	fputs(str, stream );
	return 1;
}





/* -------------------------------------------------------------------
 * 
 * 
 */
int set_line_style(FILE *stream, int style)
{
	char str[256];

//[15 1 1 1] 0 setdash






	sprintf(str, "[%d] 0 setdash\n", width);
	fputs(str, stream );
	return 1;
}





/* ====================================================================
 * ===  Copyright (C) 1998-2003 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 *    Project              : SagCAD
 *    Source               : PostScript.c
 * ====================================================================
 */
